﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class Sinuser extends Sprite
	{
		private var bmp:BitmapData;
		private var angle:Number = 0;
		private var support:Sprite = new Sprite();
		private var filterObj:BlurFilter = new BlurFilter(1.1,1.1,2);
		private var colors:Array = [0xdddddd,0xffffff];
		public function Sinuser()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			bmp = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			addChild(new Bitmap(bmp));
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function buildCycle(target:Sprite,angle:uint):Sprite
		{	
			var point:Sprite = new Sprite();
			point.graphics.beginFill(colors[angle%2],1);
			point.graphics.drawCircle(0,0,8);
			point.graphics.endFill();
			target.addChild(point);
			point.x = Math.cos(angle*2*Math.PI/180)*40;
			point.y = Math.sin(angle*Math.PI/180)*80;
			return point;
		}
		private function enterHandler(e:Event):void
		{
			var basis:Sprite = new Sprite();
			basis.x = stage.stageWidth/2;
			basis.y = stage.stageHeight/2;
			support.addChild(basis);
			for(var i:uint=0;i<500;i++){
				basis = buildCycle(basis,angle*i);
			}
			var m:Matrix = new Matrix();
			m.rotate(angle/40);
			m.scale(0.1,0.1);
			m.translate(stage.stageWidth/2,stage.stageHeight/2);
			if(Math.round(angle)%50 == 0){
				//bmp.applyFilter(bmp,bmp.rect,new Point(0,0),filterObj);
			}
			bmp.draw(support,m);
			support.removeChildAt(0);
			angle+=Math.PI/5;
			var bg:Sprite = new Sprite();
			var n:Matrix = new Matrix();
			//n.translate(stage.stageWidth/2,stage.stageHeight/2);
			bg.graphics.beginFill(0x000000, 0.005);
			bg.graphics.drawRect(0,0,stage.stageWidth, stage.stageHeight);
			if(Math.round(angle)%4 == 0) {
				bmp.draw(bg, n);
			}
		}
	}
}